#include"udf.h"

DEFINE_GRID_MOTION(vessel, domain, dt, time, dtime)
{
  Thread *tf = DT_THREAD(dt);
  face_t f;
  Node *node_p;

  real P[255][6], Y[255][7];             /*P: coefficient Y: coordinate*/
  real x, y, z;
  real delta_1=0, delta_2=0, delta_x=0;
  real J=0.0, K=0.0;
  real up_nod0,dw_nod0,up_nod1,dw_nod1;  /*0=last timestep; 1=current timestep*/
  int update_y,section_id;
  int N=time/dtime;                    /*N is time step; time is [0.001 0.255]*/
  int i, n, m, v;  

  FILE *file_1;
  FILE *file_2;

  file_1=fopen("vessel_motion_renew.mat", "r");
  file_2=fopen("vessel_node_y_renew.mat", "r");

  for(m=0;m<255;++m){ 
    for(v=0;v<6;++v){
      fscanf(file_1, "%f",&P[m][v]);  
    }
  }
 
  fclose(file_1);
  
  for(m=0;m<225;++m){
    for(v=0;v<7;++v){
      fscanf(file_2, "%f",&Y[m][v]);
    }
  }
  
  fclose(file_2);
 
  begin_f_loop(f,tf){
    f_node_loop(f,tf,n){
      node_p=F_NODE(f, tf,n);
      if(NODE_POS_NEED_UPDATE(node_p)){
	
        update_y=0;  
        section_id=-1;
        NODE_POS_UPDATED(node_p);
	z= NODE_Z (node_p); 
	y= NODE_Y (node_p);
 	x= NODE_X (node_p);
	
        if (y<0 && update_y==0){                               /*deal with y<0 section*/
          update_y=1;
          section_id=0;
          J=0;
          delta_x=x-(P[N-1][0]*pow(y,5)+P[N-1][1]*pow(y,4)+P[N-1][2]*pow(y,3)+P[N-1][3]*pow(y,2)+P[N-1][4]*pow(y,1)+P[N-1][5]);
        }   
	for(i=1;i<=6;++i){                        /*N is time step, i is node index and section index*/

          up_nod0=Y[N-1][i];                  /*last time step*/
          dw_nod0=Y[N-1][i-1];
          up_nod1=Y[N][i];                    /*current time step*/
          dw_nod1=Y[N][i-1];
          
	  if(y>=dw_nod0 && y<=up_nod0 && update_y==0){           /*IN section 1~6*/
            update_y=1;
            section_id=i;
	    delta_1=up_nod0-dw_nod0;     
            delta_2=up_nod1-dw_nod1; 	 
            delta_x=x-(P[N-1][0]*pow(y,5)+P[N-1][1]*pow(y,4)+P[N-1][2]*pow(y,3)+P[N-1][3]*pow(y,2)+P[N-1][4]*pow(y,1)+P[N-1][5]);  
	    J=(y-dw_nod0)*delta_2/delta_1+dw_nod1; 
            break;
	  }	 	   
	}
        /*in section 0*/
	/*if(update_y==0 && y<=0.0065){                            
          update_y=1;
          section_id=0;
          delta_x=x-(P[N-1][0]*pow(y,5)+P[N-1][1]*pow(y,4)+P[N-1][2]*pow(y,3)+P[N-1][3]*pow(y,2)+P[N-1][4]*pow(y,1)+P[N-1][5]);   
          J=y;          
        } */   
        if(update_y==0){                                     /*IN higher then section 6 part*/
          update_y=1;
          section_id=7;
          J=Y[N][6];
          delta_x=x-(P[N-1][0]*pow(y,5)+P[N-1][1]*pow(y,4)+P[N-1][2]*pow(y,3)+P[N-1][3]*pow(y,2)+P[N-1][4]*pow(y,1)+P[N-1][5]);
        }

	if(update_y){ 
          K= P[N][0]*pow(J,5)+P[N][1]*pow(J,4)+P[N][2]*pow(J,3)+P[N][3]*pow(J,2)+P[N][4]*pow(J,1)+P[N][5];
                                                    /* calculate X  value from motion equation */
          NODE_Z (node_p) = z;                     /* update z  value */
          NODE_Y (node_p) = J;                     /* update Y  value */
	  NODE_X (node_p) = delta_x+K ;            /* update X  value */
        }
        else{
          Message("find a un-updated point: (%g,%g)",x,y);
          Error("un-updated point error!");
        }
      }
    }
  }	 
  end_f_loop(f,tf) ;
}
	 
